#include <linux/module.h>
#include <linux/init.h>
#include <linux/crypto.h>

static int bswap16_set_key(struct crypto_tfm *tfm, const u8 *key,
			   unsigned int key_len)
{
	return 0;
}

static void bswap16_swap(struct crypto_tfm *tfm, u8 *out, const u8 *in)
{
	u8 tmp;

	/* out may be an alias of in */
	tmp = in[0];
	out[0] = in[1];
	out[1] = tmp;
}

static struct crypto_alg bswap16_alg = {
	.cra_name		= "bswap16",
	.cra_driver_name	= "bswap16-generic",
	.cra_flags		= CRYPTO_ALG_TYPE_CIPHER,
	.cra_blocksize		= 2,
	.cra_ctxsize		= 0,
	.cra_module		= THIS_MODULE,
	.cra_u			= {
		.cipher = {
			.cia_min_keysize	= 0,
			.cia_max_keysize	= 256,
			.cia_setkey		= bswap16_set_key,
			.cia_encrypt		= bswap16_swap,
			.cia_decrypt		= bswap16_swap,
		},
	},
};

static int __init bswap16_init(void)
{
	return crypto_register_alg(&bswap16_alg);
}

static void __exit bswap16_exit(void)
{
	crypto_unregister_alg(&bswap16_alg);
}

module_init(bswap16_init);
module_exit(bswap16_exit);

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("Byte swap pseudo-cipher");
MODULE_AUTHOR("Decaf Code <git@decafcode.org>");
MODULE_ALIAS_CRYPTO("bswap16");
